$regfile = "m8def.dat"
$crystal = 8000000

Config Lcd = 16 * 2
Config Lcdpin = Pin , Rs = Portc.5 , E = Portc.4 , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portc.1 , Db7 = Portc.0
Cursor Off
Cls






'Sensor connection PortD.6
Dht_put Alias Portd.6
Dht_get Alias Pind.6
Dht_io_set Alias Ddrd.6

Dim T As Byte                                               'Pereemennaya storage temperature
Dim H As Byte                                               'Variable to store moisture


Dim Crc As Byte                                             'Variable to store the parity bytes
Dim Mybyte As Byte
Dim Count As Byte                                           'Variable for counting received bits

Dim _bit As Bit
Dim A As Byte




Set Dht_io_set
Set Dht_put

Do
   Waitms 1500
   Gosub Get_th
   Cls
   Lcd "T=" ; T ; " C    H=" ; H ; "% "
Loop
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++
 Get_th:

   Count = 0
   Set Dht_io_set                                           'Do PD.6 output
   Reset Dht_put                                            'Presses the tire to the ground
   Waitms 25                                                'Wait for at least 18ms

   Set Dht_put                                              'Release the bus
   Waitus 40
   Reset Dht_io_set                                         'Do PD.6 entrance
   Waitus 40                                                'Wait for 40 ms
   If Dht_get = 1 Then                                      'If it is still 1
      H = 1                                                 'Means the sensor did not respond
      Return                                                'Exit from the subroutine
   End If
'If the sensor is said and pulled the bus to continue to work the land
   Waitus 80                                                'Wait for another 80 ms
   If Dht_get = 0 Then                                      'If the line is still 0
      H = 2                                                 'Means the sensor has gone mad
      Return                                                'Exit from the subroutine
   End If

'If everything is fine and the sensor answered correctly, then continue

   While Dht_get = 1 : Wend                                 'Waiting until you get on the bus 1
   Do                                                       'Begin to take 40 bits of data
      While Dht_get = 0 : Wend                              'Waiting for the appearance on the bus 0
      Waitus 30                                             '0 forward after the appearance 30mks
      If Dht_get = 1 Then                                   'If the tire 1
          _bit = 1
         While Dht_get = 1 : Wend                           'And wait until the sensor sends the next bit
      Else                                                  'Otherwise, if there was a 0
         _bit = 0
      End If
      '-----------------
       If Count < 8 Then
              A = 7 - Count
             H.a = _bit
       End If
      '-----------------
      If Count > 15 And Count < 24 Then
             A = 23 - Count
              T.a = _bit
      End If
       '-----------------
       If Count > 31 Then
             A = 39 - Count
              Crc.a = _bit
      End If
      '-----------------
      Incr Count                                            'Increment the counter by 1
   Loop Until Count = 40                                    'Repeat until the counter has reached the count of 40

   Set Dht_io_set
   Set Dht_put

'Checksum
   Mybyte = T + H                                           'Add up the value of temperature and humidity
   If Mybyte <> Crc Then                                    'If the checksum will not match
      H = 3                                                 'Means the data are not correct
   End If

Return                                                      'Return to the main program loop